;Comtois le 07/03/06
;Je me suis grandement inspir du tutoriel de Fauerby http://www.peroxide.dk

XIncludeFile "Include\CAR_Collision3DV3.Pbi"

;-Les procdures
Procedure SavePreferences(Fichier$)
  If CreatePreferences(Fichier$)
    PreferenceGroup("FICHIERS")
    WritePreferenceString("Fichier triangles","WaterWorldTriangles.HD")
    WritePreferenceString("Fichier mesh","WaterWorld.mesh")
    WritePreferenceString("Fichier SkyBox","")
    PreferenceGroup("GRAVITE")
    WritePreferenceFloat("X",0.0)
    WritePreferenceFloat("Y",-9.0)
    WritePreferenceFloat("Z",0.0)
    PreferenceGroup("COLLISION")
    WritePreferenceLong("Nombre de rebouclage", 5)
    WritePreferenceFloat("Distance trs faible",0.005)
    PreferenceGroup("ENTITY")
    WritePreferenceFloat("Vitesse",9.0)
    WritePreferenceFloat("Largeur",20)
    WritePreferenceFloat("Hauteur",50)
    WritePreferenceFloat("Profondeur",20)
    WritePreferenceFloat("Position X",250.0)
    WritePreferenceFloat("Position Y",1250.0)
    WritePreferenceFloat("Position Z",300.0)
    ClosePreferences()
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False 
EndProcedure
ProcedureDLL LoadPreference(Fichier$,*World3D.s_WorldCollision,*Entity.s_Collision)
  If OpenPreferences(Fichier$)
    PreferenceGroup("FICHIERS")
    *World3D\FichierTriangles=ReadPreferenceString("Fichier triangles","WaterWorldTriangles.HD")
    *World3D\FichierMesh=ReadPreferenceString("Fichier mesh","WaterWorld.mesh")
    *World3D\FichierSkyBox=ReadPreferenceString("Fichier SkyBox","")
    PreferenceGroup("GRAVITE")
    *World3D\Gravite\x=ReadPreferenceFloat("X",0.0)
    *World3D\Gravite\y=ReadPreferenceFloat("Y",-9)
    *World3D\Gravite\z=ReadPreferenceFloat("Z",0.0)
    PreferenceGroup("COLLISION")
    *World3D\RebouclageMaxi=ReadPreferenceLong("Nombre de rebouclage", 5)
    *World3D\DistanceTresFaible=ReadPreferenceFloat("Distance trs faible",0.005)
    PreferenceGroup("ENTITY")
    *Entity\Vitesse=ReadPreferenceFloat("Vitesse",9.0)
    *Entity\RayonEllipsoide\x=ReadPreferenceFloat("Largeur",25.0)
    *Entity\RayonEllipsoide\y=ReadPreferenceFloat("Hauteur",70.0)
    *Entity\RayonEllipsoide\z=ReadPreferenceFloat("Profondeur",25.0)
    *Entity\PositionDansR3\x=ReadPreferenceFloat("Position X",250.0)
    *Entity\PositionDansR3\y=ReadPreferenceFloat("Position Y",125.0)
    *Entity\PositionDansR3\z=ReadPreferenceFloat("Position Z",300.0)
    ClosePreferences()
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False 
EndProcedure
Procedure Normalise(*N.s_Vecteur)
   Define.f Norme
   
   Norme=Sqr(*N\x * *N\x + *N\y * *N\y + *N\z * *N\z)
   If Norme = 0.0
      *N\x = 0.0
      *N\y = 0.0
      *N\z = 0.0
   Else
    	*N\x / Norme
      *N\y / Norme
      *N\z / Norme
    EndIf   
EndProcedure
Procedure LongueurVecteur(*V.s_Vecteur, LongV.f)
	Define.f Norme
	Norme=Sqr(*V\x * *V\x + *V\y * *V\y + *V\z * *V\z)
	If Norme = 0
 	  *V\x = 0
 	  *V\y = 0
 	  *V\z = 0 	
	Else
 	  *V\x * LongV / Norme
 	  *V\y * LongV / Norme
 	  *V\z * LongV / Norme
 	EndIf
EndProcedure
Macro Longueur(V)
   (Sqr(V\x * V\x + V\y * V\y + V\z * V\z)) 
EndMacro
Procedure.b TestPointDansTriangleold(*P.s_Vecteur, *A.s_Vecteur, *B.s_Vecteur, *C.s_Vecteur)
	Define.s_Vecteur PA, PB, PC, Somme
	PA\x=*A\x-*P\x
	PA\y=*A\y-*P\y
	PA\z=*A\z-*P\z
	Normalise(@PA)
	PB\x=*B\x-*P\x
	PB\y=*B\y-*P\y
	PB\z=*B\z-*P\z
	Normalise(@PB)
	PC\x=*C\x-*P\x
	PC\y=*C\y-*P\y
	PC\z=*C\z-*P\z
	Normalise(@PC)
	Somme\x=PA\x+PB\x+PC\x
	Somme\y=PA\y+PB\y+PC\y
	Somme\z=PA\z+PB\z+PC\z
	;on calcule la taille du vecteur Somme
	If Longueur(Somme) > 1 
		ProcedureReturn #False
	EndIf
	ProcedureReturn #True
EndProcedure

Procedure TestPointDansTriangle1(*point.s_Vecteur, *pa.s_Vecteur, *pb.s_Vecteur, *pc.s_Vecteur)
   Define.s_Vecteur e10, e20, vp 
   Define.f a, b, c, ac_bb, d, e, x, y, z
   
   SoustractionVecteur(e10, *pb, *pa)
   SoustractionVecteur(e20, *pc, *pa)
   
   a = ProduitScalaire(e10, e10)
   b = ProduitScalaire(e10, e20)
   c = ProduitScalaire(e20, e20)
   ac_bb = (a*c)-(b*b)
   SoustractionVecteur(vp, *point, *pa)
   d = ProduitScalaire(vp, e10)
   e = ProduitScalaire(vp, e20)
   x = (d*c)-(e*b)
   y = (e*a)-(d*b)
   z = x+y-ac_bb
   ProcedureReturn ((PeekL(@z)& ~(PeekL(@x)|PeekL(@y))) & $80000000)
EndProcedure
Macro NormeAuCarre(V)
	 (V\x * V\x + V\y * V\y + V\z * V\z) 
EndMacro
Procedure.b ChercheLaPlusPetiteSolution(a.f, b.f, c.f, maxR.f, *Solution.Float)
	Define.f Determinant, t1, t2, q
	
	;Cherche les solutions d'une quation de cette forme : At+Bt+C=0
 	;http://fr.wikipedia.org/wiki/%C3%89quation_du_second_degr%C3%A9 (bas de la page "Gain de prcision")
	 	
	;Calcul le dterminant
 	Determinant = b * b - 4.0 * a * c
 	;Si le dterminant est infrieur ou gal  zro , il n'y a pas d'intersection significative.
 	If Determinant < 0.0 : ProcedureReturn #False : EndIf

	If a=0.0
		t1=-c/b
		t2=0.0
	Else
	 	;Calcul les deux solutions 
	 	If b<0.0
			q=0.5 * (-b - Sqr(Determinant)) 
		Else
			q=0.5 * (-b + Sqr(Determinant)) 
		EndIf
		t1 = q / a
 		t2 = c / q
	EndIf
	
 	;Renvoie la solution la plus petite si elle est valide
 	If t1 > 0  And t1 < maxR 
  		*Solution\f = t1
  		ProcedureReturn #True
 	EndIf
 	If t2 > 0  And t2 < maxR
  		*Solution\f = t2
  		ProcedureReturn #True
 	EndIf
 	;Pas de solution
 	ProcedureReturn #False
EndProcedure
Procedure CollisionSphereTriangle(*Sphere.s_Collision, *Boite.s_Boite, *World3D.s_WorldCollision)
	Define.s_Plan PlanTriangle
	Define.s_Triangle *Ptr
	Define.f a, b, c, f, t, t0, t1, NouveauT, NormeAreteAuCarre
	Define.f DistanceSpherePlan, PScalaireNormaleVitesse, NormeVitesseAuCarre 
	Define.f PScalaireAreteVitesse, PScalaireAreteP_Sphere
	Define.s_Vecteur Sphere_p1, p1_Sphere, Sphere_p2, p2_Sphere, Sphere_p3,	p3_Sphere
 	Define.s_Vecteur Arete, PointCollision,PointIntersectionSurLePlan 
	Define.l i, SphereCoupeLePlan, TriangleEnCollision 
	
  	*Ptr = *World3D\ListeTriangles - SizeOf(s_Triangle)
	For i = 1 To *World3D\NbTriangles
	 	*Ptr + SizeOf(s_Triangle)
	 	;A revoir , c'est pas utile de tout recopier , je pourrais utiliser directement la liste chaine ?
		CopieVecteur(PlanTriangle\Normale, *Ptr\normale)
	  CopieVecteur(PlanTriangle\Origine, *Ptr\P1) 
		PlanTriangle\Constante = *Ptr\Constante  	
	
		;Le produit scalaire <=0 si on se trouve face au triangle 
		If ProduitScalaire(PlanTriangle\Normale, *Sphere\VitesseDansBaseENormee)>=0 
			;Inverse la normale ( C'est provisoire , en attendant de faire un diteur correct qui oriente la normale dans le bon sens)
	  		PlanTriangle\Normale\x * -1
	  		PlanTriangle\Normale\y * -1
	  		PlanTriangle\Normale\z * -1
	  		PlanTriangle\Constante * -1
	  EndIf
		
	  	;Initialise t0,t1	
		t0 = 0.0 
	  	t1 = 0.0 
		
		;Initialise un drapeau   
	   SphereCoupeLePlan = #False
	   
	   ;Calcul la distance de la sphre au plan du triangle (d=N.S0+Cp : http://homeomath.imingo.net/displan.htm)
	   DistanceSpherePlan = ProduitScalaire(*Sphere\PointOrigine,PlanTriangle\normale) + PlanTriangle\Constante
	   
	   ;Calcul le produit scalaire Normale du plan avec le vecteur vitesse
	   ;Permet de dterminer si la sphre se dplace paralllement au plan 
	   PScalaireNormaleVitesse = ProduitScalaire(PlanTriangle\normale, *Sphere\VitesseDansBaseE)
	
	   ;Si la sphre se dplace paralllement au plan
	   If PScalaireNormaleVitesse>-#Epsilon And PScalaireNormaleVitesse<#Epsilon
 	   ;If PScalaireNormaleVitesse=0.0
   	   ;Il n'y a pas de collision si la distance de la Sphre au Plan est suprieure au rayon de la sphre
	   	If Abs(DistanceSpherePlan) > 1.0
	    		;La sphre ne coupe pas le plan , il n'y a pas de collision 
			   Continue 
	   	Else 
	    		;La sphre coupe le plan.elle est en collision dans l'intervalle [0..1]
	    		SphereCoupeLePlan = #True
	    		t0 = 0.0
	    		t1 = 1.0
	   	EndIf
		   
	   Else 
		  
	   	;Calcul l'intervalle dans lequel la sphre est en collision
	   	t0=(-1.0-DistanceSpherePlan)/PScalaireNormaleVitesse
	   	t1=( 1.0-DistanceSpherePlan)/PScalaireNormaleVitesse
	   	;Swap si ncessaire
	   	If t0 > t1
	   	    Swap t0,t1
	   	EndIf
	   	;Pas de collision si les deux rsultats sont hors de l'intervalle [0..1]
	   	If t0 > 1.0 Or t1 < 0.0
			   Continue 
	   	EndIf
	   	;Recadre dans l'intervalle [0,1]
	   	If t0 < 0.0 : t0 = 0.0 : EndIf
	   	If t1 > 1.0 : t1 = 1.0 : EndIf
		   
	   EndIf
	   
	   ;Maintenant on connait l'intervalle dans lequel il est possible qu'une collision se produise ,
	   ; mais on ne sait pas encore o.
	  
	   TriangleEnCollision = #False
	   t = 1.0
	   
	   ;Test si la collision est dans le triangle 
	   If SphereCoupeLePlan=#False
		   ;Position de la sphre  t0 - la Normale du plan 
	   	PointIntersectionSurLePlan\x=(*Sphere\PointOrigine\x + t0 * *Sphere\VitesseDansBaseE\x) - PlanTriangle\Normale\x
	   	PointIntersectionSurLePlan\y=(*Sphere\PointOrigine\y + t0 * *Sphere\VitesseDansBaseE\y) - PlanTriangle\Normale\y
	   	PointIntersectionSurLePlan\z=(*Sphere\PointOrigine\z + t0 * *Sphere\VitesseDansBaseE\z) - PlanTriangle\Normale\z

	     	;il faut vrifier que le point d'intersection est dans la boite du Noeud en cours
; 	   	CondX = PointIntersectionSurLePlan\x>=*Boite\Xmini And PointIntersectionSurLePlan\x<=*Boite\Xmaxi
;   			CondY = PointIntersectionSurLePlan\y>=*Boite\Ymini And PointIntersectionSurLePlan\y<=*Boite\Ymaxi
;   			CondZ = PointIntersectionSurLePlan\z>=*Boite\Zmini And PointIntersectionSurLePlan\z<=*Boite\Zmaxi
	      
	      With PointIntersectionSurLePlan
   		   If \x < *Boite\Xmini Or \x > *Boite\Xmaxi Or \y < *Boite\Ymini Or \y > *Boite\Ymaxi Or \z < *Boite\Zmini Or \z > *Boite\Zmaxi
   		   	Continue
   		   EndIf
	     	EndWith
	     	
	     	;Test si le point d'intersection se trouve dans le triangle
		   If (TestPointDansTriangle1(@PointIntersectionSurLePlan,*Ptr\p1,*Ptr\p2,*Ptr\p3))
	    		TriangleEnCollision = #True
			   ;Mmorise t et Le point en collision le plus proche  
	    		t = t0
	    		CopieVecteur(PointCollision, PointIntersectionSurLePlan)
	   	EndIf
	  EndIf
	
		;S'il n'y a pas de collision  l'intrieur du triangle , il faut tester les sommets et les artes 
		  
	  	If TriangleEnCollision = #False 
	  	
		   NormeVitesseAuCarre = NormeAuCarre(*Sphere\VitesseDansBaseE)
	
	   	;P1
	   	SoustractionVecteur(Sphere_p1, *Sphere\PointOrigine, *Ptr\p1)
	   	SoustractionVecteur(p1_Sphere, *Ptr\p1, *Sphere\PointOrigine)
		   b = 2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,Sphere_p1)
	   	c = NormeAuCarre(p1_Sphere) - 1.0
	   	If ChercheLaPlusPetiteSolution(NormeVitesseAuCarre,b,c, t, @NouveauT) 
	    		t = NouveauT
	    		TriangleEnCollision = #True
	    		CopieVecteur(PointCollision, *Ptr\p1)
	   	EndIf
		   
	   	;p1 -> p2:
	   	SoustractionVecteur(Arete, *Ptr\p2, *Ptr\p1)
	   	NormeAreteAuCarre.f = NormeAuCarre(Arete)
	   	PScalaireAreteVitesse = ProduitScalaire(Arete,*Sphere\VitesseDansBaseE)
	   	PScalaireAreteP_Sphere = ProduitScalaire(Arete,p1_Sphere)
	   	;Calcule les paramtres de l'quation
	   	a = NormeAreteAuCarre*-NormeVitesseAuCarre + PScalaireAreteVitesse*PScalaireAreteVitesse
	   	b = NormeAreteAuCarre*(2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,p1_Sphere))-2.0*PScalaireAreteVitesse*PScalaireAreteP_Sphere
	   	c = NormeAreteAuCarre*(1-NormeAuCarre(p1_Sphere))+PScalaireAreteP_Sphere*PScalaireAreteP_Sphere
	   	;Cherche si une intersection de la Sphere avec la ligne passant par l'arte existe
	   	If ChercheLaPlusPetiteSolution(a,b,c, t, @NouveauT)
	    		;Il faut vrifier que le point trouv se trouve bien sur l'arete
	    		f = (PScalaireAreteVitesse*NouveauT-PScalaireAreteP_Sphere)/NormeAreteAuCarre
	    		If f >= 0.0 And f <= 1.0
	     			t = NouveauT
	     			TriangleEnCollision = #True
	     			AdditionVecteur(PointCollision, *Ptr\p1, f * Arete)
	    		EndIf
	   	EndIf
	   
	   	;P2
	   	SoustractionVecteur(Sphere_p2, *Sphere\PointOrigine, *Ptr\p2)
	   	SousTractionVecteur(p2_Sphere, *Ptr\p2, *Sphere\PointOrigine)
	    	b = 2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,Sphere_p2)
	   	c = NormeAuCarre(p2_Sphere) - 1.0
	   	If ChercheLaPlusPetiteSolution(NormeVitesseAuCarre,b,c, t, @NouveauT)
	    		t = NouveauT
	    		TriangleEnCollision = #True
	    		CopieVecteur(PointCollision, *Ptr\p2)
	   	EndIf
		   
	   	;p2 -> p3:
	   	SoustractionVecteur(Arete,*Ptr\p3,*Ptr\p2)
	   	NormeAreteAuCarre = NormeAuCarre(Arete)
	   	PScalaireAreteVitesse = ProduitScalaire(Arete,*Sphere\VitesseDansBaseE)
	   	PScalaireAreteP_Sphere = ProduitScalaire(Arete,p2_Sphere)
	   	a = NormeAreteAuCarre*-NormeVitesseAuCarre + PScalaireAreteVitesse*PScalaireAreteVitesse
	   	b = NormeAreteAuCarre*(2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,p2_Sphere))-2.0*PScalaireAreteVitesse*PScalaireAreteP_Sphere
	   	c = NormeAreteAuCarre*(1-NormeAuCarre(p2_Sphere))+PScalaireAreteP_Sphere*PScalaireAreteP_Sphere
	   	;Cherche si une intersection de la Sphere avec la ligne passant par l'arte existe
	   	If ChercheLaPlusPetiteSolution(a,b,c, t, @NouveauT)
	    		;Il faut vrifier que le point trouv se trouve bien sur l'arete
		     	f = (PScalaireAreteVitesse*NouveauT-PScalaireAreteP_Sphere)/NormeAreteAuCarre
	    		If f >= 0.0 And f <= 1.0
	     			t = NouveauT
	     			TriangleEnCollision = #True
	     			AdditionVecteur(PointCollision, *Ptr\p2, f * Arete)
	    		EndIf
	   	EndIf
	
	   	;P3
	   	SoustractionVecteur(Sphere_p3,*Sphere\PointOrigine,*Ptr\p3)
	   	SoustractionVecteur(p3_Sphere,*Ptr\p3,*Sphere\PointOrigine)
	   	b = 2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,Sphere_p3)
	   	c = NormeAuCarre(p3_Sphere) - 1.0
	   	If ChercheLaPlusPetiteSolution(NormeVitesseAuCarre,b,c, t, @NouveauT)
	    		t = NouveauT
	    		TriangleEnCollision = #True
	    		CopieVecteur(PointCollision, *Ptr\p3)
	   	EndIf
	   
	   	;p3 -> p1:
	   	SoustractionVecteur(Arete, *Ptr\p1, *Ptr\p3)
	   	NormeAreteAuCarre = NormeAuCarre(Arete)
	   	PScalaireAreteVitesse = ProduitScalaire(Arete,*Sphere\VitesseDansBaseE)
	   	PScalaireAreteP_Sphere = ProduitScalaire(Arete,p3_Sphere)
	   	a = NormeAreteAuCarre*-NormeVitesseAuCarre +PScalaireAreteVitesse*PScalaireAreteVitesse
	   	b = NormeAreteAuCarre*(2.0 * ProduitScalaire(*Sphere\VitesseDansBaseE,p3_Sphere))-2.0*PScalaireAreteVitesse*PScalaireAreteP_Sphere
	   	c = NormeAreteAuCarre*(1-NormeAuCarre(p3_Sphere))+PScalaireAreteP_Sphere*PScalaireAreteP_Sphere
	   	;Cherche si une intersection de la Sphere avec la ligne passant par l'arte existe
	   	If ChercheLaPlusPetiteSolution(a,b,c, t, @NouveauT)
	    		;Il faut vrifier que le point trouv se trouve bien sur l'arete
	    		f = (PScalaireAreteVitesse*NouveauT-PScalaireAreteP_Sphere)/NormeAreteAuCarre
	    		If f >= 0.0 And f <= 1.0
	     			t = NouveauT
	     			TriangleEnCollision = #True
	     			AdditionVecteur(PointCollision, *Ptr\p3, f * Arete)
	    		EndIf
	   	EndIf
	  	EndIf

	  	;Stock le rsultat
	 	If TriangleEnCollision = #True 
		   ;Si c'est le premier triangle en collision ou le plus prs 
	   	If *Sphere\CollisionDetectee = #False Or t < *Sphere\DistanceLaPlusCourte 
	    		*Sphere\DistanceLaPlusCourte = t       ; Pour slectionner le triangle le plus proche
	    		CopieVecteur(*Sphere\PointIntersection, PointCollision)
	    		*Sphere\CollisionDetectee = #True
	   	EndIf
		EndIf
		
	Next
	
	*Sphere\DistanceLaPlusCourte * Longueur(*Sphere\VitesseDansBaseE)   

EndProcedure

Procedure ReponseCollision(*Reponse.s_Reponse,*World3D.s_WorldCollision)
 	Define.s_Plan PlanDeGlissement
 	Define.s_Collision Entity
	Define.s_Vecteur PointDestination, NouveauPointOrigine, V
	Define.s_Vecteur NouveauPointDestination, NouvelleVitesse
	Define.s_Vecteur Mini, Maxi, Delta 
	Define.s_Boite Boite
	Define.f Longueur1
	  
	;Limite le rebouclage 
  If (*World3D\NombreRebouclage>*World3D\RebouclageMaxi)
    CopieVecteur(*Reponse\PositionFinale, *Reponse\PositionInitiale)
  	ProcedureReturn 
 	EndIf 
 	
	;Stocke les informations ncessaires au test de collision 
 	CopieVecteur(Entity\VitesseDansBaseE, *Reponse\Vitesse)
 	CopieVecteur(Entity\VitesseDansBaseENormee, *Reponse\Vitesse)
 	Normalise(@Entity\VitesseDansBaseENormee)
 	CopieVecteur(Entity\PointOrigine, *Reponse\PositionInitiale)
 	Entity\CollisionDetectee = #False
 	
  ;Test les triangles , s'il y a collision , retourne le point d'intersection avec le triangle.
  
  Delta\x = 1.4
  Delta\y = 1.4
  Delta\z = 1.4

  Mini\x = Entity\PointOrigine\x - Delta\x 
  Mini\y = Entity\PointOrigine\y - Delta\y
  Mini\z = Entity\PointOrigine\z - Delta\z
  
  Maxi\x = Entity\PointOrigine\x + Entity\VitesseDansBaseE\x + Delta\x
  Maxi\y = Entity\PointOrigine\y + Entity\VitesseDansBaseE\y + Delta\y
  Maxi\z = Entity\PointOrigine\z + Entity\VitesseDansBaseE\z + Delta\z

  If Mini\x < Maxi\x
    Boite\Xmini = Mini\x
    Boite\Xmaxi = Maxi\x
  Else
    Boite\Xmini = Maxi\x
    Boite\Xmaxi = Mini\x
  EndIf  
  
  If Mini\y < Maxi\y
    Boite\Ymini = Mini\y
    Boite\Ymaxi = Maxi\y
  Else
    Boite\Ymini = Maxi\y
    Boite\Ymaxi = Mini\y
  EndIf 
  
  If Mini\z < Maxi\z
    Boite\Zmini = Mini\z
    Boite\Zmaxi = Maxi\z
  Else
    Boite\Zmini = Maxi\z
    Boite\Zmaxi = Mini\z
  EndIf 
	
	IntersectionBoites(@Entity,*World3D\Racine,@Boite,*World3D)
	;TestCollision(@Entity,*World3D)
	 
 	;Il n'y a pas de collision, on peut se dplacer normalement
 	If Entity\CollisionDetectee = #False
  		AdditionVecteur(*Reponse\PositionFinale, *Reponse\PositionInitiale, *Reponse\Vitesse)
  		ProcedureReturn 
 	EndIf
 
 	;Calcul le point de destination ( comme s'il n'y avait pas de collision)
 	AdditionVecteur(PointDestination, *Reponse\PositionInitiale, *Reponse\Vitesse)
 
 	CopieVecteur(NouveauPointOrigine, *Reponse\PositionInitiale)
 	
	;On se replace un peu avant le point de d'intersection calcul dans TestCollision()
 	If Entity\DistanceLaPlusCourte > *World3D\DistanceTresFaible
  		V\x = *Reponse\Vitesse\x
  		V\y = *Reponse\Vitesse\y
  		V\z = *Reponse\Vitesse\z
  		LongueurVecteur(@V, Entity\DistanceLaPlusCourte - *World3D\DistanceTresFaible)
  		NouveauPointOrigine\x + V\x
  		NouveauPointOrigine\y + V\y
  		NouveauPointOrigine\z + V\z
		    		
      ;Et on dplace aussi le point d'intersection de faon  ne pas tre en collision sur le plan de glissement
   	  Normalise(@V)
  		Entity\PointIntersection\x - *World3D\DistanceTresFaible * V\x 
  		Entity\PointIntersection\y - *World3D\DistanceTresFaible * V\y 
  		Entity\PointIntersection\z - *World3D\DistanceTresFaible * V\z 
	EndIf
	
	;Determine le plan de glissement
	CopieVecteur(PlanDeGlissement\Origine, Entity\PointIntersection)
 	SoustractionVecteur(PlanDeGlissement\Normale, NouveauPointOrigine, Entity\PointIntersection)
	Normalise(@PlanDeGlissement\Normale)
	PlanDeGlissement\Constante = -(PlanDeGlissement\Normale\x*PlanDeGlissement\Origine\x+PlanDeGlissement\Normale\y*PlanDeGlissement\Origine\y+PlanDeGlissement\Normale\z*PlanDeGlissement\Origine\z)

	;Nouveau point de destination
	Longueur1 = ProduitScalaire(Pointdestination,PlanDeGlissement\normale) + PlanDeGlissement\Constante
	SoustractionVecteur(NouveauPointDestination, PointDestination, Longueur1 * PlanDeGlissement\Normale)
  
	;Calcul la nouvelle vitesse (le long du plan de glissement)
  SoustractionVecteur(NouvelleVitesse, NouveauPointDestination, Entity\PointIntersection)
 
 	;Inutile de reboucler si la nouvelle vitesse est faible
 	If Longueur(NouvelleVitesse) <= *World3D\DistanceTresFaible
  		CopieVecteur(*Reponse\PositionFinale, NouveauPointOrigine)
  		ProcedureReturn 
 	EndIf
	
 	*World3D\NombreRebouclage + 1
	;A voir si je garde la structure 
	*Reponse\PositionInitiale\x = NouveauPointOrigine\x
	*Reponse\PositionInitiale\y = NouveauPointOrigine\y
	*Reponse\PositionInitiale\z = NouveauPointOrigine\z
	*Reponse\Vitesse\x = NouvelleVitesse\x 
	*Reponse\Vitesse\y = NouvelleVitesse\y 
	*Reponse\Vitesse\z = NouvelleVitesse\z
 	
	 ReponseCollision(*Reponse,*World3D)
EndProcedure
ProcedureDLL GestionDeplacement1(*Entity.s_Collision, *World3D.s_WorldCollision)
	Define.s_Vecteur PositionDansBaseE, VitesseDansBaseE, PositionFinale
	Define.s_Reponse Reponse
	
	;Calcul la position et la vitesse dans la base de l'Ellipsoide
	DivisionVecteur(PositionDansBaseE, *Entity\PositionDansR3, *Entity\RayonEllipsoide)
 	DivisionVecteur(VitesseDansBaseE , *Entity\VitesseDansR3 , *Entity\RayonEllipsoide)
 	
	;Gestion du dplacement
	*World3D\NombreRebouclage = 0
	CopieVecteur(Reponse\PositionFinale ,PositionFinale)
	CopieVecteur(Reponse\PositionInitiale, PositionDansBaseE)
	CopieVecteur(Reponse\Vitesse,VitesseDansBaseE) 
	;Reponse\ListeTriangles=*Entity\ListeTriangles
	ReponseCollision(@Reponse,*World3D)
 
 	;Gestion de la gravit
  DivisionVecteur(VitesseDansBaseE, *World3D\gravite, *Entity\RayonEllipsoide)
  *World3D\NombreRebouclage = 0
  CopieVecteur(Reponse\PositionInitiale,Reponse\PositionFinale)
  CopieVecteur(Reponse\Vitesse,VitesseDansBaseE) 
  ReponseCollision(@Reponse,*World3D)

 	;Conversion de la position finale dans R3
 	MultiplicationVecteur(*Entity\PositionDansR3, Reponse\PositionFinale, *Entity\RayonEllipsoide)
EndProcedure

ProcedureDLL CreateListeTriangles(*Entity.s_Collision,*World3D.s_WorldCollision)
  Define.s_Vecteur p2_p1,	p3_p1
  Define.s_Triangle *Ptr
 
  ;Gnre un fichier contenant la liste des triangles

  If ReadFile(0,*World3D\FichierTriangles)
    *World3D\NbTriangles=ReadLong(0) 
    ReadData(0,*World3D\Boite,SizeOf(s_Boite))
     
    *World3D\Boite\Xmini / *Entity\RayonEllipsoide\x
    *World3D\Boite\Ymini / *Entity\RayonEllipsoide\y
    *World3D\Boite\Zmini / *Entity\RayonEllipsoide\z
    *World3D\Boite\Xmaxi / *Entity\RayonEllipsoide\x
    *World3D\Boite\Ymaxi / *Entity\RayonEllipsoide\y
    *World3D\Boite\Zmaxi / *Entity\RayonEllipsoide\z
        
    *World3D\Boite\Xmini - #Epsilon  
    *World3D\Boite\Ymini - #Epsilon
    *World3D\Boite\Zmini - #Epsilon  
    *World3D\Boite\Xmaxi + #Epsilon   
    *World3D\Boite\Ymaxi + #Epsilon   
    *World3D\Boite\Zmaxi + #Epsilon   
        
    *World3D\ListeTriangles=AllocateMemory(SizeOf(s_Triangle) * *World3D\NbTriangles)
    *Ptr = *World3D\ListeTriangles
   
    While Eof(0)=0
      ReadData(0,*Ptr,SizeOf(s_Triangle))
      *Ptr\P1\x / *Entity\RayonEllipsoide\x
      *Ptr\P1\y / *Entity\RayonEllipsoide\y
      *Ptr\P1\z / *Entity\RayonEllipsoide\z
      *Ptr\P2\x / *Entity\RayonEllipsoide\x
      *Ptr\P2\y / *Entity\RayonEllipsoide\y
      *Ptr\P2\z / *Entity\RayonEllipsoide\z
      *Ptr\P3\x / *Entity\RayonEllipsoide\x
      *Ptr\P3\y / *Entity\RayonEllipsoide\y
      *Ptr\P3\z / *Entity\RayonEllipsoide\z   
           
      ;Calcul le plan 
	    p2_p1\x = *Ptr\P2\x - *Ptr\P1\x
	    p2_p1\y = *Ptr\P2\y - *Ptr\P1\y
	    p2_p1\z = *Ptr\P2\z - *Ptr\P1\z
	    p3_p1\x = *Ptr\P3\x - *Ptr\P1\x
	    p3_p1\y = *Ptr\P3\y - *Ptr\P1\y
	    p3_p1\z = *Ptr\P3\z - *Ptr\P1\z

	    ProduitVectoriel(*Ptr\Normale,p2_p1,p3_p1)
	    Normalise(*Ptr\Normale)
	    *Ptr\Constante = -(*Ptr\Normale\x * *Ptr\P1\x + *Ptr\Normale\y * *Ptr\P1\y + *Ptr\Normale\z * *Ptr\P1\z)
      *Ptr + SizeOf(s_Triangle)
    Wend
    CloseFile(0) 
  EndIf	
EndProcedure

Procedure CollisionRayonTriangle(*Rayon.s_Rayon, *Boite.s_Boite, *ListeTriangles.s_Triangle, NbTriangles.l)
	Define.s_Plan PlanTriangle
 	Define.s_Vecteur PointCollision,PointIntersectionSurLePlan 
	Define.s_Triangle *Ptr
	Define.f PScalaireNormalePlanRayon, DistanceRayonPlan, t
	Define.l i, CondX, CondY, CondZ
	
 	*Ptr = *ListeTriangles - SizeOf(s_Triangle)
 	For i = 1 To NbTriangles
 		*Ptr + SizeOf(s_Triangle)
		CopieVecteur(PlanTriangle\Normale, *Ptr\normale)
	  	CopieVecteur(PlanTriangle\Origine, *Ptr\P1) 
		PlanTriangle\Constante=*Ptr\Constante  	
	
; 		;Le produit scalaire <=0 si on se trouve face au triangle 
; 		If ProduitScalaire(PlanTriangle\Normale, *Rayon\DirectionDansBaseE)>=0 
; 			;Inverse la normale ( C'est provisoire , en attendant de faire un diteur correct qui oriente la normale dans le bon sens)
; 	  		PlanTriangle\Normale\x * -1
; 	  		PlanTriangle\Normale\y * -1
; 	  		PlanTriangle\Normale\z * -1
; 	  		PlanTriangle\Constante * -1
; 	  EndIf

	   ;Calcul le produit scalaire Normale du plan avec le vecteur directeur du rayon
	   PScalaireNormalePlanRayon = ProduitScalaire(PlanTriangle\normale, *Rayon\DirectionDansBaseE)
	   
	   ;Le rayon est parallle au plan
	   If PScalaireNormalePlanRayon >= -#Epsilon And PScalaireNormalePlanRayon <= #Epsilon
	   	Continue
	   EndIf
		
	   
	   ;Calcul la distance de la sphre au plan du triangle (d=N.S0+Cp : http://homeomath.imingo.net/displan.htm)
	   DistanceRayonPlan = ProduitScalaire(*Rayon\OrigineDansBaseE,PlanTriangle\normale) + PlanTriangle\Constante

  		;Intersection avec le plan
	   t = -DistanceRayonPlan / PScalaireNormalePlanRayon
       
	   ;Pas de collision 
	   If t < #Epsilon
			Continue 
	   EndIf
	   
	   ;Point d'intersection avec le plan
   	PointIntersectionSurLePlan\x=(*Rayon\OrigineDansBaseE\x + t * *Rayon\DirectionDansBaseE\x)
   	PointIntersectionSurLePlan\y=(*Rayon\OrigineDansBaseE\y + t * *Rayon\DirectionDansBaseE\y)
   	PointIntersectionSurLePlan\z=(*Rayon\OrigineDansBaseE\z + t * *Rayon\DirectionDansBaseE\z) 
	     		     	
	   ;il faut vrifier que le point d'intersection est dans la boite du Noeud en cours
	   CondX = PointIntersectionSurLePlan\x>=*Boite\Xmini And PointIntersectionSurLePlan\x<=*Boite\Xmaxi
  		CondY = PointIntersectionSurLePlan\y>=*Boite\Ymini And PointIntersectionSurLePlan\y<=*Boite\Ymaxi
  		CondZ = PointIntersectionSurLePlan\z>=*Boite\Zmini And PointIntersectionSurLePlan\z<=*Boite\Zmaxi
	   
	   If (Not CondX) Or (Not CondY) Or (Not CondZ)
	   	Continue
	   EndIf
	   
	  	;Stock le rsultat
	 	If (TestPointDansTriangle1(@PointIntersectionSurLePlan, *Ptr\p1, *Ptr\p2, *Ptr\p3))
		   ;Si c'est le premier triangle en collision ou le plus prs 
	   	If *Rayon\CollisionDetectee = #False Or t < *Rayon\DistanceLaPlusCourte 
	    		*Rayon\DistanceLaPlusCourte = t      ; Pour slectionner le triangle le plus proche
	    		CopieVecteur(*Rayon\PointIntersection, PointIntersectionSurLePlan)
	    		*Rayon\CollisionDetectee = #True
	   	EndIf
		EndIf
		
	Next

EndProcedure
; IDE Options = PureBasic v4.00 - Beta 6 (Windows - x86)
; CursorPosition = 179
; FirstLine = 167
; Folding = ---
; Executable = CAR_Collision3DV1.exe