#Focale = 50
#SQRT13 = 0.57735026 

Enumeration 
	#World3D
	#Robot
	#Sphere
	#Sphere1
	#Faisceau
	#Particule
EndEnumeration

Structure s_Screen 
	Width.l
   Height.l
   Depth.l
	Width_2.l
	Height_2.l
EndStructure

Structure s_Vertex
	px.f
	py.f
	pz.f
	nx.f
	ny.f
	nz.f
	Couleur.l
EndStructure

Define.l ScreenWidth,ScreenHeight,ScreenDepth,ScreenWidth_2,ScreenHeight_2
Define.l i, NbTour, CouleurAlerte
Define.f MouseX, MouseY, PasX, PasZ, Fov, cx, cy, cz, TpsTir, Delta
Define.s_Entity Camera, Robot
Define.s_Screen Screen
Define.s_Collision InfosNinja
Define.s_WorldCollision World3D
Define.s_Sphere Sphere
Define.s Texte

Fov = #Focale
Delta = 0.1
	
Macro Divers
LoadPreference("Collision2.ini",@World3D,@InfosNinja)
CreateListeTriangles(@InfosNinja,@World3D)
World3D\Racine = AllocateMemory(SizeOf(s_Octree))
World3D\Racine\Niveau = 0
World3D\Racine\NbTriangles = 0
World3D\Racine\ListeTriangles = #Null
For i = 0 To 7
    World3D\Racine\Fils[i] = #Null 
Next i
ConstructionOctree(World3D\Racine,World3D\Boite,World3D\ListeTriangles,World3D\NbTriangles)   
;-Texture
CreateTexture(#Faisceau,64,64)
StartDrawing(TextureOutput(#Faisceau))
Box(0,0,64,64,$FFFFFF)
StopDrawing()
LoadTexture(#Sphere,"RustySteel.jpg")

;-Material
CreateMaterial(#Faisceau,TextureID(#Faisceau))
DisableMaterialLighting(#Faisceau, 1)
MaterialAmbientColor(#Faisceau,#PB_Material_AmbientColors)

CreateMaterial(#Sphere,TextureID(#Sphere))
MaterialBlendingMode(#Sphere,#PB_Material_Add)

;- Mesh
LoadMesh(#World3D, World3D\FichierMesh)
LoadMesh(#Sphere , "Sphere.mesh")
LoadMesh(#Robot  , "Robot.mesh")
CreateMesh(#Faisceau, 2000) 
SetMeshData(#Faisceau, #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_Color, ?CubeData2, 8)
SetMeshData(#Faisceau, #PB_Mesh_Face, ?CubeDataIndex, 12) 

;- World3D
CreateEntity(#World3D, MeshID(#World3D), 0) 

;- Spheres
CreateEntity(#Sphere,MeshID(#Sphere),MaterialID(#Sphere))
ScaleEntity(#Sphere, 0.8,1.8,0.8)
EntityLocate(#Sphere,-180,0,300)

CreateEntity(#Sphere1,MeshID(#Sphere),0)
ScaleEntity(#Sphere1, 0.05,0.05,0.05)

;- Robot
Robot\No = #Robot
CreateEntity(#Robot,MeshID(#Robot),0)
EntityLocate(#Robot, -180, 5, 300)
ScaleEntity(#Robot, 1.8,1.8,1.8)
;AnimateEntity(Robot\No, "Walk")

;-Faisceau
CreateEntity(#Faisceau,MeshID(#Faisceau),MaterialID(#Faisceau))

;-Particules
CreateMaterial(#Particule, LoadTexture(#Particule, "Flare.png"))
DisableMaterialLighting(#Particule, 1)
MaterialBlendingMode(#Particule,2)
    
    
CreateParticleEmitter(#Particule, 12, 5, 12, #PB_Particle_Point)
ParticleMaterial     (#Particule, MaterialID(#Particule))
ParticleTimeToLive   (#Particule, 0.3, 0.3) 
ParticleEmissionRate (#Particule, 20) 
ParticleSize         (#Particule, 25, 25) 
ParticleColorRange   (#Particule, RGB(0,0,0), RGB(255,0,0))  
  
;-SkyBox
If World3D\FichierSkyBox
    SkyBox(World3D\FichierSkyBox)
EndIf

;-Light 
AmbientColor(0)
CreateLight(0,RGB(255,155,0),-180, 400, 300)
CreateLight(1,RGB(55,55,255),-180, 200, -800)
CreateLight(2,RGB(75,55,160),-180, -90, 3700)
CreateLight(3,RGB(60,155,60),-180, 0, 3000)
;-Camera
CreateCamera(0,0,0,100,100)
CameraFOV(0,#Focale*0.0174533)

CameraLocate(0,InfosNinja\PositionDansR3\x, InfosNinja\PositionDansR3\y , InfosNinja\PositionDansR3\z)
CameraLookAt(0,InfosNinja\PositionDansR3\x + CosDeg(0) * 100, InfosNinja\PositionDansR3\y ,InfosNinja\PositionDansR3\z - SinDeg(0) * 100)

EndMacro



Procedure ModificationMeshFaisceau(*Rayon.s_Rayon, Dvertex.f)
   Define.s_Vertex *PtrV	

	*PtrV = ?CubeData2
	With *Rayon
   	*PtrV\px = \Origine\x - DVertex
   	*PtrV\py = \Origine\y + DVertex	
   	*PtrV\pz = \Origine\z - DVertex
   	*PtrV + SizeOf(s_Vertex)
   	*PtrV\px = \Origine\x + DVertex
   	*PtrV\py = \Origine\y + DVertex	
   	*PtrV\pz = \Origine\z - DVertex
   	*PtrV + SizeOf(s_Vertex)
   	*PtrV\px = \Origine\x + DVertex
   	*PtrV\py = \Origine\y - DVertex	
   	*PtrV\pz = \Origine\z - DVertex
   	*PtrV + SizeOf(s_Vertex)
   	*PtrV\px = \Origine\x - DVertex
   	*PtrV\py = \Origine\y - DVertex	
   	*PtrV\pz = \Origine\z - DVertex
   	*PtrV + SizeOf(s_Vertex)
   	
   	*PtrV\px = \PointIntersection\x - DVertex
   	*PtrV\py = \PointIntersection\y + DVertex	
   	*PtrV\pz = \PointIntersection\z + DVertex
   	*PtrV + SizeOf(s_Vertex)
   	*PtrV\px = \PointIntersection\x + DVertex
   	*PtrV\py = \PointIntersection\y + DVertex	
   	*PtrV\pz = \PointIntersection\z + DVertex
   	*PtrV + SizeOf(s_Vertex)	
   	*PtrV\px = \PointIntersection\x + DVertex
   	*PtrV\py = \PointIntersection\y - DVertex	
   	*PtrV\pz = \PointIntersection\z + DVertex
   	*PtrV + SizeOf(s_Vertex)
   	*PtrV\px = \PointIntersection\x - DVertex
   	*PtrV\py = \PointIntersection\y - DVertex	
   	*PtrV\pz = \PointIntersection\z + DVertex
   	*PtrV + SizeOf(s_Vertex)
	EndWith	
	
	SetMeshData(#Faisceau, #PB_Mesh_Vertex | #PB_Mesh_Normal | #PB_Mesh_Color, ?CubeData2, 8)	
	
EndProcedure

Macro AffichageEcran
    StartDrawing(ScreenOutput())
    	;DrawingMode(#PB_2DDrawing_Transparent)
    	DrawText(0,  0, StrF(Engine3DFrameRate(#PB_Engine3D_Current), 0))
      DrawText(0, 20, Texte,CouleurAlerte, $00FFFF)
      ;DrawText(0,40,StrF(CameraX(0), 2) + " / " + StrF(CameraY(0),2) + " / " + StrF(CameraZ(0), 2))
    	LineXY(Screen\Width_2 - 5, Screen\Height_2 - 5, Screen\Width_2 + 5, Screen\Height_2 + 5, $FFFFFF)
    	LineXY(Screen\Width_2 + 5, Screen\Height_2 - 5, Screen\Width_2 - 5, Screen\Height_2 + 5, $FFFFFF)
    StopDrawing()
EndMacro
	

DataSection
  CubeData2:
   
    Data.f -100.0,100.0,-100.0
    Data.f -#SQRT13,#SQRT13,-#SQRT13
    Data.l  $FF0000               
    
    Data.f 100.0,100.0,-100.0
    Data.f #SQRT13,#SQRT13,-#SQRT13
    Data.l  $FF0000  
    
    Data.f 100.0,-100.0,-100.0
    Data.f #SQRT13,-#SQRT13,-#SQRT13
    Data.l  $FF0000 
    
    Data.f -100.0,-100.0,-100.0
    Data.f -#SQRT13,-#SQRT13,-#SQRT13
    Data.l  $FF0000 
    
    Data.f -100.0,100.0,100.0
    Data.f -#SQRT13,#SQRT13,#SQRT13
    Data.l  $FF0000  
    
    Data.f 100.0,100.0,100.0
    Data.f #SQRT13,#SQRT13,#SQRT13
    Data.l  $FF0000 
    
    Data.f 100.0,-100.0,100.0
    Data.f #SQRT13,-#SQRT13,#SQRT13
    Data.l $FF0000 
    
    Data.f -100.0,-100.0,100.0
    Data.f -#SQRT13,-#SQRT13,#SQRT13
    Data.l  $FF0000  

  CubeDataIndex:
    Data.w 0,2,3
    Data.w 0,1,2
    Data.w 1,6,2
    Data.w 1,5,6
    Data.w 4,6,5
    Data.w 4,7,6
    Data.w 0,7,4
    Data.w 0,3,7
    Data.w 0,5,1
    Data.w 0,4,5
    Data.w 2,7,3
    Data.w 2,6,7
EndDataSection 



; IDE Options = PureBasic v4.00 - Beta 6 (Windows - x86)
; CursorPosition = 136
; FirstLine = 115
; Folding = --