;Fonctions Math
#Racine2 = 1.41421353816986

Structure s_Vecteur
  x.f
  y.f
  z.f
EndStructure

Structure s_Boite
  Xmini.f
  Ymini.f
  Zmini.f
  Xmaxi.f
  Ymaxi.f
  Zmaxi.f
EndStructure

Structure s_Rayon
	;Informations dans R3
	Origine.s_Vecteur
	Direction.s_Vecteur
	;Informations Dans la base de l'ellipsoide
	OrigineDansBaseE.s_Vecteur
	DirectionDansBaseE.s_Vecteur
	;Informations collisions
 	CollisionDetectee.l
 	DistanceLaPlusCourte.f
 	PointIntersection.s_Vecteur	 
EndStructure	

Structure s_Sphere
	;Informations Dans R3
	Origine.s_Vecteur
	Rayon.f
	DistanceCarre.f
EndStructure

Macro CopieVecteur(V,V1)
  V\x=V1\x
  V\y=V1\y
  V\z=V1\z
EndMacro 

Macro AdditionVecteur(V,V1,V2)
  V\x=V1\x + V2\x
  V\y=V1\y + V2\y
  V\z=V1\z + V2\z
EndMacro 

Macro SoustractionVecteur(V,V1,V2)
   V\x = V1\x - V2\x
  	V\y = V1\y - V2\y
  	V\z = V1\z - V2\z
EndMacro 

Macro DivisionVecteur(V,V1,V2)
  	V\x = V1\x / V2\x
  	V\y = V1\y / V2\y
  	V\z = V1\z / V2\z
EndMacro 

Macro MultiplicationVecteur(V,V1,V2)
  	V\x = V1\x * V2\x
  	V\y = V1\y * V2\y
  	V\z = V1\z * V2\z
EndMacro 

Macro ProduitScalaire(V1, V2)
  	(V1\x * V2\x + V1\y * V2\y + V1\z * V2\z) 
EndMacro

Macro ProduitVectoriel(N,V1,V2)
	N\x = ((V1\y * V2\z) - (V1\z * V2\y))
   N\y = ((V1\z * V2\x) - (V1\x * V2\z))
   N\z = ((V1\x * V2\y) - (V1\y * V2\x))
EndMacro

Macro DistanceAuCarre(V1,V2)
   ((V1\x - V2\x) * (V1\x - V2\x) + (V1\y - V2\y) * (V1\y - V2\y) + (V1\z - V2\z) * (V1\z - V2\z))
EndMacro

Macro CosDeg(Angle) 
	Cos((Angle) * 0.0174533) 
EndMacro

Macro SinDeg(Angle) 
  Sin((Angle) * 0.0174533) 
EndMacro

Macro NewXValue(x, Angle, Distance) 
  ((x) + Cos((Angle) * 0.0174533) * (Distance))
EndMacro

Macro NewZValue(z, Angle, Distance)
  ((z) - Sin((Angle) * 0.0174533) * (Distance))
EndMacro

Procedure.f WrapValue(angle.f); <- wraps a value into [0,360) fringe
  ;Psychophanta : http://purebasic.fr/english/viewtopic.php?t=18635  
  !fild dword[@f] ; <- now i have 360 into st0
  !fld dword[p.v_angle]
  !fprem
  !fadd st1,st0
  !fldz
  !fcomip st1
  !fcmovnbe st0,st1
  !fstp st1
  ProcedureReturn
  !@@:dd 360
EndProcedure 

Procedure.f EcartAngle(Angle1.f, Angle2.f) 
	Define.f Delta
	
	Delta=Angle2-Angle1 
  	If Delta>180 
    	ProcedureReturn Delta-360 
  	ElseIf Delta<=-180 
    	ProcedureReturn Delta+360 
  	Else 
    	ProcedureReturn Delta 
  	EndIf    
EndProcedure 

Procedure.f  CurveValue(actuelle.f, Cible.f, P.f) 
  Define.f Delta, Valeur
  
  Delta = Cible - actuelle 
  If P > 1000 : P = 1000 : EndIf 
  Valeur = actuelle + ( Delta * P / 1000) 
  ProcedureReturn Valeur 
EndProcedure 

Procedure.f CurveAngle(actuelle.f, Cible.f, P.f) 
	Define.f Delta
	
  	Delta = EcartAngle(actuelle , Cible) 
  	If P > 1000 : P = 1000 : EndIf 
  	ProcedureReturn WrapValue(actuelle + (Delta * P / 1000)) 
EndProcedure 


; IDE Options = PureBasic v4.00 - Beta 6 (Windows - x86)
; CursorPosition = 35
; Folding = ----