;Comtois le 06/03/06
;Octree version Alpha 1
;Vrifier que lors de la rpartition des triangles dans les boites aucun ne soit laiss de ct !

XIncludeFile "Include\Maths.Pbi"
XIncludeFile "Include\Octree.Pbi"
XIncludeFile "Include\RayonBoite.pb"
XIncludeFile "Include\Collision triangle BoxV1.pb"

Procedure ConstructionOctree(*Noeud.s_Octree, *Boite.s_Boite, *ListeTriangles.s_Triangle, NbTriangles)
  Define.s_Boite BoiteFils
  Define.s_Triangle *ListeTrianglesFils, *Ptr
  Define.s_Vecteur CentreBoite, DemiDimensionBoite
  Define.s_Octree	 *PtrF
  Define.l x, y, z, i, t, NbTrianglesFils
   
  Dim SommetsTriangle.s_Vecteur(2)
  NewList ListeTriangles.s_Triangle()
  
  CopieBoite(*Noeud\Boite, *Boite)
  
  ; Le noeud peut tre partag ?
  If Nbtriangles > #NbTriangles And *Noeud\Niveau < #Taille

    ;On rpartit les triangles dans les noeuds fils

    For y = 0 To 1 
      For z = 0 To 1
        For x = 0 To 1
          
          ;No du fils 
          i = (y<<2)|(z<<1)|x
          
          ;Boite englobante du fils i
          BoiteFils\Xmini = (1.0 - x / 2.0) * *Boite\Xmini  + x / 2.0 * *Boite\Xmaxi
          BoiteFils\Xmaxi = BoiteFils\Xmini + (*Boite\Xmaxi - *Boite\Xmini) / 2.0
          BoiteFils\Ymini = (1.0 - y / 2.0) * *Boite\Ymini  + y / 2.0 * *Boite\Ymaxi
          BoiteFils\Ymaxi = BoiteFils\Ymini + (*Boite\Ymaxi - *Boite\Ymini) / 2.0  
          BoiteFils\Zmini = (1.0 - z / 2.0) * *Boite\Zmini  + z / 2.0 * *Boite\Zmaxi
          BoiteFils\Zmaxi = BoiteFils\Zmini + (*Boite\Zmaxi - *Boite\Zmini) / 2.0  
          
          ;Informations pour dterminer si un triangle est en collision avec la boite
          CentreBoite\x        = (BoiteFils\Xmaxi + BoiteFils\Xmini) / 2.0
          CentreBoite\y        = (BoiteFils\Ymaxi + BoiteFils\Ymini) / 2.0
          CentreBoite\z        = (BoiteFils\Zmaxi + BoiteFils\Zmini) / 2.0
          DemiDimensionBoite\x = (BoiteFils\Xmaxi - BoiteFils\Xmini) / 2.0
          DemiDimensionBoite\y = (BoiteFils\Ymaxi - BoiteFils\Ymini) / 2.0
          DemiDimensionBoite\z = (BoiteFils\Zmaxi - BoiteFils\Zmini) / 2.0
         
          *Ptr = *ListeTriangles 
          
          ClearList(ListeTriangles())
            
          For t = 1 To NbTriangles 
           
            CopyMemory(*Ptr, SommetsTriangle(), SizeOf(s_Vecteur) * 3)
            
            ; Calcul les triangles en collision avec la boite du fils i
            If triBoxOverlap(@CentreBoite, @DemiDimensionBoite, SommetsTriangle())   
                
              AddElement(ListeTriangles())
  
              CopyMemory(*Ptr, ListeTriangles(), SizeOf(s_Triangle))
             
            EndIf
            
            *Ptr + SizeOf(s_Triangle)
           
          Next t

          NbTrianglesFils = CountList(ListeTriangles())
          
          *ListeTrianglesFils = #Null 
          
          If NbTrianglesFils  
            
            *ListeTrianglesFils = AllocateMemory(SizeOf(s_Triangle) * NbTrianglesFils)
            *Ptr = *ListeTrianglesFils
            
            ForEach ListeTriangles()
              CopyMemory(ListeTriangles(), *Ptr, SizeOf(s_Triangle))
              *Ptr + SizeOf(s_Triangle)
            Next 
            
          EndIf

          ;Ajoute un Noeud
          *Noeud\Fils[i]=AllocateMemory(SizeOf(s_Octree))
        
          *PtrF = *Noeud\Fils[i]
          *PtrF\Niveau = *Noeud\Niveau + 1
        
          ConstructionOctree(*Noeud\Fils[i], @BoiteFils, *ListeTrianglesFils, NbTrianglesFils)
          
        Next x
      Next z
    Next y 

  Else 
  
    ; Affecte la liste des triangles au noeud en cours
    *Noeud\ListeTriangles = *ListeTriangles 
    *Noeud\NbTriangles = NbTriangles

  EndIf
  
EndProcedure

Procedure IntersectionBoites(*Entity.s_Collision, *Noeud.s_Octree, *BoiteEnglobante.s_Boite, *World3D.s_WorldCollision)
	Define.l x, y, z, i
		
  	; Teste si la boite est en collision 

  	If *BoiteEnglobante\Xmaxi>=*Noeud\Boite\Xmini And *BoiteEnglobante\Xmini<=*Noeud\Boite\Xmaxi And *BoiteEnglobante\Ymaxi>=*Noeud\Boite\Ymini And *BoiteEnglobante\Ymini<=*Noeud\Boite\Ymaxi And *BoiteEnglobante\Zmaxi>=*Noeud\Boite\Zmini And *BoiteEnglobante\Zmini<=*Noeud\Boite\Zmaxi

    	If *Noeud\ListeTriangles 

      	*World3D\ListeTriangles = *Noeud\ListeTriangles

      	*World3D\NbTriangles = *Noeud\NbTriangles
      
      	CollisionSphereTriangle(*Entity, *Noeud\Boite, *World3D)

    	Else

      	For i = 0 To 7

        	If *Noeud\Fils[i]
            
          	IntersectionBoites(*Entity, *Noeud\Fils[i], *BoiteEnglobante, *World3D)

        	EndIf
            
      	Next i
 
    	EndIf
      
  	EndIf
  	
  	     
EndProcedure

Procedure LancerRayon(*Noeud.s_Octree, *Rayon.s_Rayon, *Entity.s_Collision)
   Define.s_Step Etape
   DivisionVecteur(*Rayon\OrigineDansBaseE, *Rayon\Origine, *Entity\RayonEllipsoide)
	Normalise(*Rayon\Direction)
	*Rayon\CollisionDetectee = 0
	*Rayon\DistanceLaPlusCourte = 2147483647.0 
	DivisionVecteur(*Rayon\DirectionDansBaseE, *Rayon\Direction, *Entity\RayonEllipsoide)
	
	If *Rayon\DirectionDansBaseE\x >=0
		Etape\Initx = 0
			Etape\Stepx = 1
	Else
			Etape\Initx = 1
			Etape\Stepx = -1
	EndIf
	If *Rayon\DirectionDansBaseE\y >=0
			Etape\Inity = 0
			Etape\Stepy = 1
	Else
			Etape\Inity = 1
			Etape\Stepy = -1
	EndIf
	If *Rayon\DirectionDansBaseE\z >=0
			Etape\Initz = 0
			Etape\Stepz = 1
	Else
			Etape\Initz = 1
			Etape\Stepz = -1
	EndIf
		
	Etape\Endx = 1 - Etape\Initx + Etape\Stepx
	Etape\Endy = 1 - Etape\Inity + Etape\Stepy
	Etape\Endz = 1 - Etape\Initz + Etape\Stepz

   IntersectionRayonOctree(*Noeud, *Rayon, @Etape)
	MultiplicationVecteur(*Rayon\PointIntersection, *Rayon\PointIntersection, *Entity\RayonEllipsoide)
	
EndProcedure

Procedure IntersectionRayonOctree(*Noeud.s_Octree, *Rayon.s_Rayon, *Etape.s_Step)
	Define.l x, y, z, i
	
	; Teste si le rayon pntre la boite  
	If IntersectionRayonBoite(*Rayon,*Noeud\Boite) 
		 
		 If *Noeud\ListeTriangles 

			CollisionRayonTriangle(*Rayon, *Noeud\Boite, *Noeud\ListeTriangles, *Noeud\NbTriangles)
			
			If *Rayon\CollisionDetectee 
					
				ProcedureReturn #True
				
			EndIf	
		
		Else
			
			;Vrifier si les boites sont testes dans le bon ordre !!
			y = *Etape\Inity
	
			While y <> *Etape\Endy   
	
				z = *Etape\Initz
	
				While z <> *Etape\Endz 
	
					x = *Etape\Initx
	
			   	While x <> *Etape\Endx 
			   		
			   		;No du fils 
			         i = (y<<2)|(z<<1)|x
						 
						If *Noeud\Fils[i] 
         
          				IntersectionRayonOctree(*Noeud\Fils[i], *Rayon, *Etape)

          			EndIf
          			
          			x + *Etape\Stepx	
          			         
			      Wend
			      
			      z + *Etape\Stepz
			      
			   Wend
			   
			   y + *Etape\Stepy
			   
			Wend  
		EndIf	

	EndIf
	    
EndProcedure

Procedure FreeOctree(*Noeud.s_Octree)
  
EndProcedure







    
    

; IDE Options = PureBasic v4.00 - Beta 6 (Windows - x86)
; CursorPosition = 12
; FirstLine = 5
; Folding = -